target datalayout = "e-p:64:64:64-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:64:64-f32:32:32-f64:64:64-v16:16:16-v24:32:32-v32:32:32-v48:64:64-v64:64:64-v96:128:128-v128:128:128-v192:256:256-v256:256:256-v512:512:512-v1024:1024:1024"
target triple = "spir64-unknown-unknown"

@destMemory = addrspace(1) global [32 x i32] zeroinitializer, align 4
@finishedThreads = addrspace(1) global i32 0, align 4

; Function Attrs: nounwind
declare spir_func i32 @__builtin_spirv_OpAtomicOr_p1i32_i32_i32_i32(i32 addrspace(1)*, i32, i32, i32) #0

; Function Attrs: nounwind
declare spir_func i32 @__builtin_spirv_OpAtomicAnd_p1i32_i32_i32_i32(i32 addrspace(1)*, i32, i32, i32) #0

; Function Attrs: nounwind readnone
declare spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalInvocationId() #1

; Function Attrs: nounwind
declare spir_func i32 @__builtin_spirv_OpAtomicIAdd_p1i32_i32_i32_i32(i32 addrspace(1)*, i32, i32, i32) #0

; Function Attrs: nounwind readnone
declare spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalSize() #1

; Function Attrs: nounwind
declare spir_func i32 @__builtin_spirv_OpAtomicLoad_p1i32_i32_i32(i32 addrspace(1)*, i32, i32) #0

; Function Attrs: nounwind
define spir_func void @test_atomic_function(i32 %tid, i32 %threadCount, i32 %numDestItems, i32 addrspace(1)* %destMemory, i32 addrspace(1)* %oldValues) #0 {
  %div = udiv i32 %tid, 32
  %conv = zext i32 %div to i64
  %rem = urem i32 %tid, 32
  %shl.mask = and i32 %rem, 31
  %shl = shl i32 1, %shl.mask
  %idxprom = zext i32 %tid to i64
  %1 = getelementptr inbounds i32, i32 addrspace(1)* %oldValues, i64 %idxprom
  store i32 0, i32 addrspace(1)* %1, align 4
  br label %2

2:                                                ; preds = %15, %0
  %i.0 = phi i32 [ 0, %0 ], [ %inc13, %15 ]
  %cmp = icmp slt i32 %i.0, 10000
  br i1 %cmp, label %4, label %3

3:                                                ; preds = %2
  br label %16

4:                                                ; preds = %2
  %5 = getelementptr inbounds i32, i32 addrspace(1)* %destMemory, i64 %conv
  %call = call spir_func i32 @__builtin_spirv_OpAtomicOr_p1i32_i32_i32_i32(i32 addrspace(1)* %5, i32 0, i32 8, i32 %shl) #0
  %and = and i32 %call, %shl
  %tobool = icmp ne i32 %and, 0
  br i1 %tobool, label %6, label %9

6:                                                ; preds = %4
  %idxprom2 = zext i32 %tid to i64
  %7 = getelementptr inbounds i32, i32 addrspace(1)* %oldValues, i64 %idxprom2
  %8 = load i32, i32 addrspace(1)* %7, align 4
  %inc = add i32 %8, 1
  store i32 %inc, i32 addrspace(1)* %7, align 4
  br label %9

9:                                                ; preds = %6, %4
  %10 = getelementptr inbounds i32, i32 addrspace(1)* %destMemory, i64 %conv
  %neg = xor i32 %shl, -1
  %call5 = call spir_func i32 @__builtin_spirv_OpAtomicAnd_p1i32_i32_i32_i32(i32 addrspace(1)* %10, i32 0, i32 8, i32 %neg) #0
  %and6 = and i32 %call5, %shl
  %tobool7 = icmp ne i32 %and6, 0
  br i1 %tobool7, label %14, label %11

11:                                               ; preds = %9
  %idxprom9 = zext i32 %tid to i64
  %12 = getelementptr inbounds i32, i32 addrspace(1)* %oldValues, i64 %idxprom9
  %13 = load i32, i32 addrspace(1)* %12, align 4
  %inc11 = add i32 %13, 1
  store i32 %inc11, i32 addrspace(1)* %12, align 4
  br label %14

14:                                               ; preds = %11, %9
  br label %15

15:                                               ; preds = %14
  %inc13 = add nsw i32 %i.0, 1
  br label %2

16:                                               ; preds = %3
  ret void
}

; Function Attrs: nounwind
define spir_kernel void @test_atomic_kernel(i32 %threadCount, i32 %numDestItems, i32 addrspace(1)* %finalDest, i32 addrspace(1)* %oldValues) #0 {
  %1 = call spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalInvocationId() #1
  %call = extractelement <3 x i64> %1, i32 0
  %conv = trunc i64 %call to i32
  %2 = getelementptr inbounds [32 x i32], [32 x i32] addrspace(1)* @destMemory, i64 0, i64 0
  call spir_func void @test_atomic_function(i32 %conv, i32 %threadCount, i32 %numDestItems, i32 addrspace(1)* %2, i32 addrspace(1)* %oldValues) #0
  %call1 = call spir_func i32 @__builtin_spirv_OpAtomicIAdd_p1i32_i32_i32_i32(i32 addrspace(1)* @finishedThreads, i32 2, i32 0, i32 1) #0
  %conv2 = zext i32 %call1 to i64
  %3 = call spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalSize() #1
  %call3 = extractelement <3 x i64> %3, i32 0
  %sub = sub i64 %call3, 1
  %cmp = icmp eq i64 %conv2, %sub
  br i1 %cmp, label %4, label %12

4:                                                ; preds = %0
  br label %5

5:                                                ; preds = %10, %4
  %dstItemIdx.0 = phi i32 [ 0, %4 ], [ %inc, %10 ]
  %cmp5 = icmp ult i32 %dstItemIdx.0, %numDestItems
  br i1 %cmp5, label %7, label %6

6:                                                ; preds = %5
  br label %11

7:                                                ; preds = %5
  %idx.ext = zext i32 %dstItemIdx.0 to i64
  %8 = getelementptr inbounds i32, i32 addrspace(1)* %2, i64 %idx.ext
  %call7 = call spir_func i32 @__builtin_spirv_OpAtomicLoad_p1i32_i32_i32(i32 addrspace(1)* %8, i32 2, i32 0) #0
  %idxprom = zext i32 %dstItemIdx.0 to i64
  %9 = getelementptr inbounds i32, i32 addrspace(1)* %finalDest, i64 %idxprom
  store volatile i32 %call7, i32 addrspace(1)* %9, align 4
  br label %10

10:                                               ; preds = %7
  %inc = add i32 %dstItemIdx.0, 1
  br label %5

11:                                               ; preds = %6
  br label %12

12:                                               ; preds = %11, %0
  ret void
}

attributes #0 = { nounwind }
attributes #1 = { nounwind readnone }

!opencl.kernels = !{!0}
!IGCMetadata = !{!7}
!opencl.enable.FP_CONTRACT = !{}
!opencl.spir.version = !{!240}
!opencl.ocl.version = !{!240}
!opencl.used.extensions = !{!241}
!opencl.used.optional.core.features = !{!241}
!opencl.compiler.options = !{!242}

!0 = !{void (i32, i32, i32 addrspace(1)*, i32 addrspace(1)*)* @test_atomic_kernel, !1, !2, !3, !4, !5, !6}
!1 = !{!"kernel_arg_addr_space", i32 0, i32 0, i32 1, i32 1}
!2 = !{!"kernel_arg_access_qual", !"none", !"none", !"none", !"none"}
!3 = !{!"kernel_arg_type", !"int", !"int", !"int*", !"int*"}
!4 = !{!"kernel_arg_type_qual", !"", !"", !"volatile", !""}
!5 = !{!"kernel_arg_base_type", !"int", !"int", !"int*", !"int*"}
!6 = !{!"kernel_arg_name", !"threadCount", !"numDestItems", !"finalDest", !"oldValues"}
!7 = !{!"ModuleMD", !8, !9, !64, !121, !151, !167, !179, !189, !191, !192, !203, !204, !205, !206, !209, !210, !211, !212, !213, !214, !215, !216, !217, !218, !219, !220, !222, !226, !227, !228, !229, !230, !231, !108, !232, !233, !235, !238, !239}
!8 = !{!"isPrecise", i1 false}
!9 = !{!"compOpt", !10, !11, !12, !13, !14, !15, !16, !17, !18, !19, !20, !21, !22, !23, !24, !25, !26, !27, !28, !29, !30, !31, !32, !33, !34, !35, !36, !37, !38, !39, !40, !41, !42, !43, !44, !45, !46, !47, !48, !49, !50, !51, !52, !53, !54, !55, !56, !57, !58, !59, !60, !61, !62, !63}
!10 = !{!"DenormsAreZero", i1 false}
!11 = !{!"CorrectlyRoundedDivSqrt", i1 false}
!12 = !{!"OptDisable", i1 false}
!13 = !{!"MadEnable", i1 false}
!14 = !{!"NoSignedZeros", i1 false}
!15 = !{!"NoNaNs", i1 false}
!16 = !{!"FloatRoundingMode", i32 0}
!17 = !{!"FloatCvtIntRoundingMode", i32 3}
!18 = !{!"VISAPreSchedRPThreshold", i32 0}
!19 = !{!"SetLoopUnrollThreshold", i32 0}
!20 = !{!"UnsafeMathOptimizations", i1 false}
!21 = !{!"FiniteMathOnly", i1 false}
!22 = !{!"FastRelaxedMath", i1 false}
!23 = !{!"DashGSpecified", i1 false}
!24 = !{!"FastCompilation", i1 false}
!25 = !{!"UseScratchSpacePrivateMemory", i1 true}
!26 = !{!"RelaxedBuiltins", i1 false}
!27 = !{!"SubgroupIndependentForwardProgressRequired", i1 true}
!28 = !{!"GreaterThan2GBBufferRequired", i1 true}
!29 = !{!"GreaterThan4GBBufferRequired", i1 true}
!30 = !{!"DisableA64WA", i1 false}
!31 = !{!"ForceEnableA64WA", i1 false}
!32 = !{!"PushConstantsEnable", i1 true}
!33 = !{!"HasPositivePointerOffset", i1 false}
!34 = !{!"HasBufferOffsetArg", i1 false}
!35 = !{!"BufferOffsetArgOptional", i1 true}
!36 = !{!"HasSubDWAlignedPtrArg", i1 false}
!37 = !{!"replaceGlobalOffsetsByZero", i1 false}
!38 = !{!"forcePixelShaderSIMDMode", i32 0}
!39 = !{!"pixelShaderDoNotAbortOnSpill", i1 false}
!40 = !{!"UniformWGS", i1 false}
!41 = !{!"disableVertexComponentPacking", i1 false}
!42 = !{!"disablePartialVertexComponentPacking", i1 false}
!43 = !{!"PreferBindlessImages", i1 false}
!44 = !{!"UseBindlessMode", i1 false}
!45 = !{!"UseLegacyBindlessMode", i1 true}
!46 = !{!"disableMathRefactoring", i1 false}
!47 = !{!"atomicBranch", i1 false}
!48 = !{!"ForceMinSimdSizeForFastestCS", i1 false}
!49 = !{!"EnableFastestLinearScan", i1 false}
!50 = !{!"UseStatelessforPrivateMemory", i1 false}
!51 = !{!"EnableTakeGlobalAddress", i1 false}
!52 = !{!"IsLibraryCompilation", i1 false}
!53 = !{!"FastVISACompile", i1 false}
!54 = !{!"MatchSinCosPi", i1 false}
!55 = !{!"CaptureCompilerStats", i1 false}
!56 = !{!"EnableZEBinary", i1 false}
!57 = !{!"ExcludeIRFromZEBinary", i1 false}
!58 = !{!"allowDisableRematforCS", i1 false}
!59 = !{!"DisableIncSpillCostAllAddrTaken", i1 false}
!60 = !{!"DisableCPSOmaskWA", i1 false}
!61 = !{!"DisableFastestGopt", i1 false}
!62 = !{!"WaForceHalfPromotion", i1 false}
!63 = !{!"EnableUndefAlphaOutputAsRed", i1 true}
!64 = !{!"FuncMD", !65, !66}
!65 = !{!"FuncMDMap[0]", void (i32, i32, i32 addrspace(1)*, i32 addrspace(1)*)* @test_atomic_kernel}
!66 = !{!"FuncMDValue[0]", !67, !68, !72, !73, !74, !94, !100, !101, !102, !103, !104, !105, !106, !107, !108, !109, !110, !111, !112, !113, !114, !115, !116, !117, !118, !119, !120}
!67 = !{!"localOffsets"}
!68 = !{!"workGroupWalkOrder", !69, !70, !71}
!69 = !{!"dim0", i32 0}
!70 = !{!"dim1", i32 0}
!71 = !{!"dim2", i32 0}
!72 = !{!"funcArgs"}
!73 = !{!"functionType", !"KernelFunction"}
!74 = !{!"rtInfo", !75, !76, !77, !78, !79, !80, !81, !82, !83, !84, !85, !86, !87, !88, !89, !93}
!75 = !{!"callableShaderType", !"NumberOfCallableShaderTypes"}
!76 = !{!"isContinuation", i1 false}
!77 = !{!"hasTraceRayPayload", i1 false}
!78 = !{!"hasHitAttributes", i1 false}
!79 = !{!"hasCallableData", i1 false}
!80 = !{!"ShaderStackSize", i32 0}
!81 = !{!"ShaderHash", i64 0}
!82 = !{!"ShaderName", !""}
!83 = !{!"ParentName", !""}
!84 = !{!"SlotNum", i1* null}
!85 = !{!"NOSSize", i32 0}
!86 = !{!"Entries"}
!87 = !{!"SpillUnions"}
!88 = !{!"CustomHitAttrSizeInBytes", i32 0}
!89 = !{!"Types", !90, !91, !92}
!90 = !{!"FrameStartTys"}
!91 = !{!"ArgumentTys"}
!92 = !{!"FullFrameTys"}
!93 = !{!"Aliases"}
!94 = !{!"resAllocMD", !95, !96, !97, !98, !99}
!95 = !{!"uavsNumType", i32 0}
!96 = !{!"srvsNumType", i32 0}
!97 = !{!"samplersNumType", i32 0}
!98 = !{!"argAllocMDList"}
!99 = !{!"inlineSamplersMD"}
!100 = !{!"maxByteOffsets"}
!101 = !{!"IsInitializer", i1 false}
!102 = !{!"IsFinalizer", i1 false}
!103 = !{!"CompiledSubGroupsNumber", i32 0}
!104 = !{!"hasInlineVmeSamplers", i1 false}
!105 = !{!"localSize", i32 0}
!106 = !{!"localIDPresent", i1 false}
!107 = !{!"groupIDPresent", i1 false}
!108 = !{!"privateMemoryPerWI", i32 0}
!109 = !{!"globalIDPresent", i1 false}
!110 = !{!"hasSyncRTCalls", i1 false}
!111 = !{!"hasNonKernelArgLoad", i1 false}
!112 = !{!"hasNonKernelArgStore", i1 false}
!113 = !{!"hasNonKernelArgAtomic", i1 false}
!114 = !{!"UserAnnotations"}
!115 = !{!"m_OpenCLArgAddressSpaces"}
!116 = !{!"m_OpenCLArgAccessQualifiers"}
!117 = !{!"m_OpenCLArgTypes"}
!118 = !{!"m_OpenCLArgBaseTypes"}
!119 = !{!"m_OpenCLArgTypeQualifiers"}
!120 = !{!"m_OpenCLArgNames"}
!121 = !{!"pushInfo", !122, !123, !124, !127, !128, !129, !130, !131, !132, !133, !134, !147, !148, !149, !150}
!122 = !{!"pushableAddresses"}
!123 = !{!"bindlessPushInfo"}
!124 = !{!"dynamicBufferInfo", !125, !126}
!125 = !{!"firstIndex", i32 0}
!126 = !{!"numOffsets", i32 0}
!127 = !{!"MaxNumberOfPushedBuffers", i32 0}
!128 = !{!"inlineConstantBufferSlot", i32 -1}
!129 = !{!"inlineConstantBufferOffset", i32 -1}
!130 = !{!"inlineConstantBufferGRFOffset", i32 -1}
!131 = !{!"constants"}
!132 = !{!"inputs"}
!133 = !{!"constantReg"}
!134 = !{!"simplePushInfoArr", !135, !144, !145, !146}
!135 = !{!"simplePushInfoArrVec[0]", !136, !137, !138, !139, !140, !141, !142, !143}
!136 = !{!"cbIdx", i32 0}
!137 = !{!"pushableAddressGrfOffset", i32 -1}
!138 = !{!"pushableOffsetGrfOffset", i32 -1}
!139 = !{!"offset", i32 0}
!140 = !{!"size", i32 0}
!141 = !{!"isStateless", i1 false}
!142 = !{!"isBindless", i1 false}
!143 = !{!"simplePushLoads"}
!144 = !{!"simplePushInfoArrVec[1]", !136, !137, !138, !139, !140, !141, !142, !143}
!145 = !{!"simplePushInfoArrVec[2]", !136, !137, !138, !139, !140, !141, !142, !143}
!146 = !{!"simplePushInfoArrVec[3]", !136, !137, !138, !139, !140, !141, !142, !143}
!147 = !{!"simplePushBufferUsed", i32 0}
!148 = !{!"pushAnalysisWIInfos"}
!149 = !{!"inlineRTGlobalPtrOffset", i32 0}
!150 = !{!"rtSyncSurfPtrOffset", i32 0}
!151 = !{!"psInfo", !152, !153, !154, !155, !156, !157, !158, !159, !160, !161, !162, !163, !164, !165, !166}
!152 = !{!"BlendStateDisabledMask", i8 0}
!153 = !{!"SkipSrc0Alpha", i1 false}
!154 = !{!"DualSourceBlendingDisabled", i1 false}
!155 = !{!"ForceEnableSimd32", i1 false}
!156 = !{!"outputDepth", i1 false}
!157 = !{!"outputStencil", i1 false}
!158 = !{!"outputMask", i1 false}
!159 = !{!"blendToFillEnabled", i1 false}
!160 = !{!"forceEarlyZ", i1 false}
!161 = !{!"hasVersionedLoop", i1 false}
!162 = !{!"forceSingleSourceRTWAfterDualSourceRTW", i1 false}
!163 = !{!"NumSamples", i8 0}
!164 = !{!"blendOptimizationMode"}
!165 = !{!"colorOutputMask"}
!166 = !{!"WaDisableVRS", i1 false}
!167 = !{!"csInfo", !168, !169, !170, !171, !172, !18, !19, !173, !174, !175, !176, !177, !47, !178}
!168 = !{!"maxWorkGroupSize", i32 0}
!169 = !{!"waveSize", i32 0}
!170 = !{!"ComputeShaderSecondCompile"}
!171 = !{!"forcedSIMDSize", i8 0}
!172 = !{!"forceTotalGRFNum", i32 0}
!173 = !{!"forcedVISAPreRAScheduler", i1 false}
!174 = !{!"disableLocalIdOrderOptimizations", i1 false}
!175 = !{!"disableDispatchAlongY", i1 false}
!176 = !{!"neededThreadIdLayout", i1* null}
!177 = !{!"forceTileYWalk", i1 false}
!178 = !{!"ResForHfPacking"}
!179 = !{!"msInfo", !180, !181, !182, !183, !184, !185, !186, !187, !188}
!180 = !{!"PrimitiveTopology", i32 3}
!181 = !{!"MaxNumOfPrimitives", i32 0}
!182 = !{!"MaxNumOfVertices", i32 0}
!183 = !{!"MaxNumOfPerPrimitiveOutputs", i32 0}
!184 = !{!"MaxNumOfPerVertexOutputs", i32 0}
!185 = !{!"WorkGroupSize", i32 0}
!186 = !{!"WorkGroupMemorySizeInBytes", i32 0}
!187 = !{!"IndexFormat", i32 6}
!188 = !{!"SubgroupSize", i32 0}
!189 = !{!"taskInfo", !190, !185, !186, !188}
!190 = !{!"MaxNumOfOutputs", i32 0}
!191 = !{!"NBarrierCnt", i32 0}
!192 = !{!"rtInfo", !193, !194, !195, !196, !197, !198, !199, !200, !201, !202}
!193 = !{!"RayQueryAllocSizeInBytes", i32 0}
!194 = !{!"NumContinuations", i32 -1}
!195 = !{!"RTAsyncStackAddrspace", i32 -1}
!196 = !{!"RTAsyncStackSurfaceStateOffset", i1* null}
!197 = !{!"SWHotZoneAddrspace", i32 -1}
!198 = !{!"SWHotZoneSurfaceStateOffset", i1* null}
!199 = !{!"SWStackAddrspace", i32 -1}
!200 = !{!"SWStackSurfaceStateOffset", i1* null}
!201 = !{!"RTSyncStackAddrspace", i32 -1}
!202 = !{!"RTSyncStackSurfaceStateOffset", i1* null}
!203 = !{!"CurUniqueIndirectIdx", i32 0}
!204 = !{!"inlineDynTextures"}
!205 = !{!"inlineResInfoData"}
!206 = !{!"immConstant", !207, !208}
!207 = !{!"data"}
!208 = !{!"sizes"}
!209 = !{!"inlineConstantBuffers"}
!210 = !{!"inlineGlobalBuffers"}
!211 = !{!"GlobalPointerProgramBinaryInfos"}
!212 = !{!"ConstantPointerProgramBinaryInfos"}
!213 = !{!"GlobalBufferAddressRelocInfo"}
!214 = !{!"ConstantBufferAddressRelocInfo"}
!215 = !{!"forceLscCacheList"}
!216 = !{!"SrvMap"}
!217 = !{!"RasterizerOrderedByteAddressBuffer"}
!218 = !{!"MinNOSPushConstantSize", i32 0}
!219 = !{!"inlineProgramScopeOffsets"}
!220 = !{!"shaderData", !221}
!221 = !{!"numReplicas", i32 0}
!222 = !{!"URBInfo", !223, !224, !225}
!223 = !{!"has64BVertexHeaderInput", i1 false}
!224 = !{!"has64BVertexHeaderOutput", i1 false}
!225 = !{!"hasVertexHeader", i1 true}
!226 = !{!"UseBindlessImage", i1 false}
!227 = !{!"enableRangeReduce", i1 false}
!228 = !{!"allowMatchMadOptimizationforVS", i1 false}
!229 = !{!"disableMemOptforNegativeOffsetLoads", i1 false}
!230 = !{!"statefulResourcesNotAliased", i1 false}
!231 = !{!"disableMixMode", i1 false}
!232 = !{!"PrivateMemoryPerFG"}
!233 = !{!"capabilities", !234}
!234 = !{!"globalVariableDecorationsINTEL", i1 false}
!235 = !{!"m_ShaderResourceViewMcsMask", !236, !237}
!236 = !{!"m_ShaderResourceViewMcsMaskVec[0]", i64 0}
!237 = !{!"m_ShaderResourceViewMcsMaskVec[1]", i64 0}
!238 = !{!"computedDepthMode", i32 0}
!239 = !{!"isHDCFastClearShader", i1 false}
!240 = !{i32 3, i32 0}
!241 = !{}
!242 = !{!"-cl-std=CL3.0"}
